//----------------------------------------------------------------------------------------------------------------------
// VersionManager
//----------------------------------------------------------------------------------------------------------------------

import { BehaviorSubject, Observable } from 'rxjs';

// Resource Access
import versionRA from '../resource-access/version.js';

//----------------------------------------------------------------------------------------------------------------------

class VersionManager
{
    #versionSubject : BehaviorSubject<string | null> = new BehaviorSubject<string | null>(null);

    //------------------------------------------------------------------------------------------------------------------
    // Properties
    //------------------------------------------------------------------------------------------------------------------

    get version$() : Observable<string | null> { return this.#versionSubject.asObservable(); }

    get version() : string | null { return this.#versionSubject.getValue(); }

    //------------------------------------------------------------------------------------------------------------------

    async init() : Promise<void>
    {
        this.#versionSubject.next(await versionRA.getVersion());
    }
}

//----------------------------------------------------------------------------------------------------------------------

export default new VersionManager();

//----------------------------------------------------------------------------------------------------------------------
